function math.clamp(input, lo, hi)
    if input < lo then
        input = lo
    elseif input > hi then
        input = hi
    end
    return input
end

function math.softclamp(input, lo, hi, strength, dt)
    if input > hi then
        return input - dt * strength
    elseif input < lo then
        return input + dt * strength
    end
    return input
end

function math.wrap(input, lo, hi)
    if input > hi then
        input = input - (hi - lo)
    elseif input < lo then
        input = input + (hi - lo)
    end
    return input
end

function checkCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function math.sign(input)
--Turns any number into it's sign
    if input > 0 then return 1 else return -1 end
end

function math.bolsig(bol)
--Turns a boolean into a sign
    if bol then return 1 else return -1 end
end

function math.boltext(bol)
--Turns a boolean into text
    if bol then return 'true' else return 'false' end
end

function CartesianToPolar(x, y)
    return math.sqrt(math.pow(x,2)+math.pow(y,2)), (math.atan(y/x)*180)/math.pi
end

function PolarToCartesian(r, a)
    return r*math.cos((a*math.pi)/180.0), r*math.sin((a*math.pi)/180.0)
end

function math.dist(x1, y1, x2, y2)
    return math.sqrt((x2 - x1)^2 + (y2 - y1)^2)
end

function math.idk(idk)
    if idk > math.pi then idk = math.pi - (idk - math.pi) end
    return idk
end

function cubic(a, b, c, d, t)
   return (((1-t)^3)*a + 3*((1-t)^2)*t*b + 3*(1-t)*(t^2)*c + (t^3)*d)
end